diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index ad1a1e9f0..58b7e4e4f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -11,15 +11,13 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockTrapDoor extends Block implements IPaintable {
+public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     public static final int DIRECTION_SOUTH = 0;
     public static final int DIRECTION_NORTH = 1;
     public static final int DIRECTION_EAST = 2;
@@ -29,8 +27,8 @@ public class BlockTrapDoor extends Block implements IPaintable {
     public static final int MASK_OPEN = 0b0000_0100;
     public static final int MASK_UPPER_HALF = 0b0000_1000;
 
-    public BlockTrapDoor(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
+    public BlockLogicTrapDoor(Block<?> block, Material material) {
+        super(block, material);
         float f = 0.5F;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
@@ -92,7 +90,7 @@ public class BlockTrapDoor extends Block implements IPaintable {
 
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
-        if (blockMaterial != Material.metal && blockMaterial != Material.steel) {
+        if (material != Material.metal && material != Material.steel) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
@@ -103,7 +101,7 @@ public class BlockTrapDoor extends Block implements IPaintable {
 
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, TileEntityActivator activator, Direction direction) {
-        if (blockMaterial != Material.metal && blockMaterial != Material.steel) {
+        if (material != Material.metal && material != Material.steel) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
@@ -116,7 +114,7 @@ public class BlockTrapDoor extends Block implements IPaintable {
             return;
         }
 
-        Block block = Blocks.getBlock(blockId);
+        Block<?> block = Blocks.getBlock(blockId);
         if (block == null || block.isSignalSource()) {
             int meta = world.getBlockMetadata(x, y, z);
             boolean isOpened = isTrapdoorOpen(meta);
@@ -140,10 +138,10 @@ public class BlockTrapDoor extends Block implements IPaintable {
 
     @Override
     public boolean isClimbable(World world, int x, int y, int z) {
-        Block block = world.getBlock(x, y - 1, z);
+        Block<?> block = world.getBlock(x, y - 1, z);
         int meta = world.getBlockMetadata(x, y, z);
-        if (isTrapdoorOpen(meta) && block instanceof BlockLadder) {
-            BlockLadder ladder = (BlockLadder) block;
+        if (isTrapdoorOpen(meta) && (block != null && block.getLogic() instanceof BlockLogicLadder)) {
+            BlockLogicLadder ladder = (BlockLogicLadder) block.getLogic();
             Side ladderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y - 1, z));
             Direction trapdoorDirection = getDirectionForMeta(meta);
             return ladderSide.getDirection().getOpposite() == trapdoorDirection;
@@ -197,12 +195,12 @@ public class BlockTrapDoor extends Block implements IPaintable {
 
     @Override
     public boolean canBePainted() {
-        return blockMaterial == Material.wood;
+        return material == Material.wood;
     }
 
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TRAPDOOR_PLANKS_PAINTED.id, meta & 0xF | color.blockMeta << 4);
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TRAPDOOR_PLANKS_PAINTED.id(), meta & 0xF | color.blockMeta << 4);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
index daa594a01..9a0deb9aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTrapDoorPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoorPainted.java
@@ -10,9 +10,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockTrapDoorPainted extends BlockTrapDoor implements IPainted {
-    public BlockTrapDoorPainted(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
+public class BlockLogicTrapDoorPainted extends BlockLogicTrapDoor implements IPainted {
+    public BlockLogicTrapDoorPainted(Block<?> block, Material material) {
+        super(block, material);
     }
     
     @Override
@@ -44,7 +44,7 @@ public class BlockTrapDoorPainted extends BlockTrapDoor implements IPainted {
     @Override
     public void removeDye(World world, int x, int y, int z) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TRAPDOOR_PLANKS_OAK.id, meta & 0xF);
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TRAPDOOR_PLANKS_OAK.id(), meta & 0xF);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTrommel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTrommel.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
index 2f73d17eb..facc7586c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
@@ -14,13 +14,14 @@ import org.slf4j.Logger;
 
 import java.util.Random;
 
-public class BlockTrommel extends BlockTileEntityRotatable
+public class BlockLogicTrommel extends BlockLogicRotatable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-	public BlockTrommel(String key, String namespaceId, int id, Material material, boolean isActive)
+	public BlockLogicTrommel(Block<?> block, Material material, boolean isActive)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         this.isActive = isActive;
+        block.withEntity(TileEntityTrommel::new);
     }
 
     @Override
@@ -75,10 +76,10 @@ public class BlockTrommel extends BlockTileEntityRotatable
         keepTrommelInventory = true;
         if(lit)
         {
-            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_ACTIVE.id);
+            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_ACTIVE.id());
         } else
         {
-            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_IDLE.id);
+            world.setBlockWithNotify(x, y, z, Blocks.TROMMEL_IDLE.id());
         }
         keepTrommelInventory = false;
         world.setBlockMetadataWithNotify(x, y, z, l);
@@ -86,13 +87,6 @@ public class BlockTrommel extends BlockTileEntityRotatable
         world.setBlockTileEntity(x, y, z, tileEntity);
     }
 
-
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityTrommel();
-    }
-
     private boolean isActive;
     public static boolean keepTrommelInventory = false;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTileEntityVeryRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTileEntityVeryRotatable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
index 7f43eca35..5c33ced29 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTileEntityVeryRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicVeryRotatable.java
@@ -7,10 +7,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public abstract class BlockTileEntityVeryRotatable extends BlockTileEntityRotatable {
+public class BlockLogicVeryRotatable extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
-	public BlockTileEntityVeryRotatable(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
+    public BlockLogicVeryRotatable(Block<?> block, Material material) {
+        super(block, material);
     }
 
     @Override
@@ -33,4 +33,4 @@ public abstract class BlockTileEntityVeryRotatable extends BlockTileEntityRotata
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
 
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
similarity index 90%
rename from game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index f53ec0923..f8d281138 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -17,12 +17,12 @@ import java.util.HashSet;
 import java.util.Random;
 import java.util.Set;
 
-public class BlockWireRedstone extends Block {
+public class BlockLogicWireRedstone extends BlockLogic {
     private boolean shouldSignal = true;
     private final Set<ChunkPosition> toUpdate = new HashSet<>();
 
-    public BlockWireRedstone(String key, String namespaceId, int id) {
-        super(key, namespaceId, id, Material.decoration);
+    public BlockLogicWireRedstone(Block<?> block) {
+        super(block, Material.decoration);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
     }
 
@@ -51,7 +51,7 @@ public class BlockWireRedstone extends Block {
         ArrayList<ChunkPosition> toUpdate = new ArrayList<>(this.toUpdate);
         this.toUpdate.clear();
         for (ChunkPosition pos : toUpdate) {
-            world.notifyBlocksOfNeighborChange(pos.x, pos.y, pos.z, id);
+            world.notifyBlocksOfNeighborChange(pos.x, pos.y, pos.z, id());
         }
     }
 
@@ -101,7 +101,7 @@ public class BlockWireRedstone extends Block {
         }
         if (strength != newStrength) {
             int blockId = world.getBlockId(x0, y0, z0);
-            if (blockId == id || blockId == Blocks.FLUID_LAVA_STILL.id || blockId == Blocks.FLUID_LAVA_FLOWING.id) { // Intentionally keeping lava transmutation, do not delete carelessly
+            if (blockId == id() || blockId == Blocks.FLUID_LAVA_STILL.id() || blockId == Blocks.FLUID_LAVA_FLOWING.id()) { // Intentionally keeping lava transmutation, do not delete carelessly
                 world.noNeighborUpdate = true;
                 world.setBlockMetadataWithNotify(x0, y0, z0, newStrength);
                 world.markBlocksDirty(x0, y0, z0, x0, y0, z0);
@@ -157,14 +157,14 @@ public class BlockWireRedstone extends Block {
     }
 
     private void checkCornerChangeAt(World world, int x, int y, int z) {
-        if (world.getBlockId(x, y, z) == id) {
-            world.notifyBlocksOfNeighborChange(x, y, z, id);
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+        if (world.getBlockId(x, y, z) == id()) {
+            world.notifyBlocksOfNeighborChange(x, y, z, id());
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, id());
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, id());
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
         }
     }
 
@@ -175,8 +175,8 @@ public class BlockWireRedstone extends Block {
             return;
         }
         updatePowerStrength(world, x, y, z);
-        world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-        world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
+        world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
         checkCornerChangeAt(world, x - 1, y, z);
         checkCornerChangeAt(world, x + 1, y, z);
         checkCornerChangeAt(world, x, y, z - 1);
@@ -209,8 +209,8 @@ public class BlockWireRedstone extends Block {
         if (world.isClientSide) {
             return;
         }
-        world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-        world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
+        world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
         updatePowerStrength(world, x, y, z);
         checkCornerChangeAt(world, x - 1, y, z);
         checkCornerChangeAt(world, x + 1, y, z);
@@ -239,7 +239,7 @@ public class BlockWireRedstone extends Block {
     }
 
     private int checkTarget(World world, int x, int y, int z, int sourceStrength) {
-        if (world.getBlockId(x, y, z) != id) {
+        if (world.getBlockId(x, y, z) != id()) {
             return sourceStrength;
         }
 
@@ -344,7 +344,7 @@ public class BlockWireRedstone extends Block {
 
     public static boolean shouldConnectTo(WorldSource worldSource, int x, int y, int z, int data) {
         int blockId = worldSource.getBlockId(x, y, z);
-        if (blockId == Blocks.WIRE_REDSTONE.id) {
+        if (blockId == Blocks.WIRE_REDSTONE.id()) {
             return true;
         }
         if (blockId <= 0) {
@@ -353,7 +353,7 @@ public class BlockWireRedstone extends Block {
         if (Blocks.blocksList[blockId].isSignalSource()) {
             return true;
         }
-        if (blockId == Blocks.PUMPKIN_REDSTONE.id) {
+        if (blockId == Blocks.PUMPKIN_REDSTONE.id()) {
             if (data < 0 || data > 3) {
                 return false;
             }
@@ -361,9 +361,9 @@ public class BlockWireRedstone extends Block {
             Side side = Side.getSideById(worldSource.getBlockMetadata(x, y, z));
             return side == lookup[data];
         }
-        if (blockId == Blocks.REPEATER_IDLE.id || blockId == Blocks.REPEATER_ACTIVE.id) {
+        if (blockId == Blocks.REPEATER_IDLE.id() || blockId == Blocks.REPEATER_ACTIVE.id()) {
             int meta = worldSource.getBlockMetadata(x, y, z);
-            return data == BlockBed.footToHeadMap[meta & 0b11];
+            return data == BlockLogicBed.footToHeadMap[meta & 0b11];
         } else {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockWool.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWool.java
similarity index 88%
rename from game/core/src/main/java/net/minecraft/core/block/BlockWool.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicWool.java
index 9c15e00ca..8df4d3256 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockWool.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWool.java
@@ -10,11 +10,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockWool extends Block implements IPainted
+public class BlockLogicWool extends BlockLogic implements IPainted
 {
-    public BlockWool(String key, String namespaceId, int id) {
+    public BlockLogicWool(Block<?> block) {
 
-        super(key, namespaceId, id, Material.cloth);
+        super(block, Material.cloth);
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockWorkbench.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
similarity index 76%
rename from game/core/src/main/java/net/minecraft/core/block/BlockWorkbench.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
index 19540ea0e..68d59df2a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockWorkbench.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
@@ -5,12 +5,12 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockWorkbench extends Block
+public class BlockLogicWorkbench extends BlockLogic
 {
 
-	public BlockWorkbench(String key, String namespaceId, int id)
+	public BlockLogicWorkbench(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 961b5ae59..d0c56f5d2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -2,12 +2,13 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
-import net.minecraft.core.block.piston.BlockPistonBase;
-import net.minecraft.core.block.piston.BlockPistonHead;
-import net.minecraft.core.block.piston.BlockPistonMoving;
-import net.minecraft.core.block.piston.BlockPistonBaseSteel;
-import net.minecraft.core.block.piston.BlockPistonBaseSticky;
+import net.minecraft.core.block.piston.BlockLogicPistonBase;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
+import net.minecraft.core.block.piston.BlockLogicPistonMoving;
+import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
+import net.minecraft.core.block.piston.BlockLogicPistonBaseSticky;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
@@ -16,23 +17,24 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.block.ItemBlockAlgae;
 import net.minecraft.core.item.block.ItemBlockLadder;
-import net.minecraft.core.item.block.ItemBlockLayerLeaves;
 import net.minecraft.core.item.block.ItemBlockPainted;
 import net.minecraft.core.item.block.ItemBlockStairsPainted;
 import net.minecraft.core.item.block.ItemBlockLamp;
 import net.minecraft.core.item.block.ItemBlockSlabPainted;
 import net.minecraft.core.sound.BlockSounds;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.world.Dimension;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Arrays;
 import java.util.HashMap;
 import java.util.LinkedHashMap;
 import java.util.Map;
 
 public final class Blocks {
-    public static final @Nullable Block @NotNull [] blocksList = new Block[16384];
-    public static final Map<NamespaceID, Block> blockMap = new LinkedHashMap<>();
+    public static final @Nullable Block<?> @NotNull [] blocksList = new Block<?>[16384];
+    public static final Map<NamespaceID, Block<?>> blockMap = new LinkedHashMap<>();
     @Deprecated public static final Map<String, Integer> keyToIdMap = new HashMap<>();
     public static final boolean[] shouldTick = new boolean[blocksList.length];
     public static final boolean[] solid = new boolean[blocksList.length];
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 41ff5a94d..16ffaba39 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Block;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -54,7 +54,7 @@ public class TileEntity implements ICarriable
         }
     }
 
-    public Block getBlock() {
+    public Block<?> getBlock() {
         if (carriedBlock != null) {
             return carriedBlock.block();
         } else {
@@ -132,7 +132,7 @@ public class TileEntity implements ICarriable
         y = blockY + side.getOffsetY();
         z = blockZ + side.getOffsetZ();
 
-        Block currentBlock = world.getBlock(x, y, z);
+        Block<?> currentBlock = world.getBlock(x, y, z);
         if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
         world.setBlockAndMetadata(x, y, z, carriedBlock.blockId, carriedBlock.metadata);
 
@@ -140,7 +140,7 @@ public class TileEntity implements ICarriable
         this.validate();
         world.removeBlockTileEntity(x, y, z);
         world.setBlockTileEntity(x, y, z, this);
-        Block b = world.getBlock(x, y, z);
+        Block<?> b = world.getBlock(x, y, z);
         if (b != null && holder instanceof Mob) {
             b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
         }
@@ -175,7 +175,7 @@ public class TileEntity implements ICarriable
 
     @Override
     public ICarriable pickup(World world, Entity holder) {
-        Block currentBlock = world.getBlock(x, y, z);
+        Block<?> currentBlock = world.getBlock(x, y, z);
         int currentMeta = world.getBlockMetadata(x, y, z);
         world.removeBlockTileEntity(x, y, z);
         world.setBlockRaw(x, y, z, 0);
@@ -185,7 +185,7 @@ public class TileEntity implements ICarriable
         return carriedBlock;
     }
 
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
         return new CarriedBlock(holder, currentBlock, currentMeta, this);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index dd6b623f9..9f35209bb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRotatable;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -233,7 +233,7 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, BlockRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, BlockLogicRotatable.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 7c317a9d4..7f4698c60 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -99,7 +99,7 @@ public class TileEntityBasket extends TileEntity
 		}
 
 		updateNumUnits();
-        world.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+        world.notifyBlockChange(x, y, z, Blocks.BASKET.id());
 	}
 
     @Override
@@ -142,21 +142,20 @@ public class TileEntityBasket extends TileEntity
 
         final AABB aabb = AABB.getTemporaryBB(posX, posY, posZ, posX + 1, posY + 2, posZ + 1);
 
-        final List<Entity> entities = workingWorld.getEntitiesWithinAABB(EntityItem.class, aabb);
+        final List<EntityItem> entities = workingWorld.getEntitiesWithinAABB(EntityItem.class, aabb);
 
         boolean shouldUpdate = false;
 
         if (!entities.isEmpty())
         {
-            for (final Entity e : entities)
+            for (final EntityItem e : entities)
             {
-                final EntityItem entity = (EntityItem) e;
-                if (entity.item != null && entity.item.stackSize > 0 && entity.basketPickupDelay == 0)
+                if (e.item != null && e.item.stackSize > 0 && e.basketPickupDelay == 0)
                 {
-                    shouldUpdate = importItemStack(entity.item);
-                    if (entity.item.stackSize <= 0)
+                    shouldUpdate = importItemStack(e.item);
+                    if (e.item.stackSize <= 0)
                     {
-                        entity.item.stackSize = 0;
+                        e.item.stackSize = 0;
                         e.outOfWorld();
                     }
                 }
@@ -166,7 +165,7 @@ public class TileEntityBasket extends TileEntity
         if (shouldUpdate)
         {
             if (worldObj != null) {
-                worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+                worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id());
             }
             updateNumUnits();
         }
@@ -230,7 +229,7 @@ public class TileEntityBasket extends TileEntity
 
         contents.clear();
 
-        world.notifyBlockChange(x, y, z, Blocks.BASKET.id);
+        world.notifyBlockChange(x, y, z, Blocks.BASKET.id());
         updateNumUnits();
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 3b69525d4..441ee6897 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.BlockLogicChest;
 import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -157,8 +157,8 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, BlockChest.getMetaWithDirection(BlockChest.getMetaWithType(currentMeta, BlockChest.Type.SINGLE), Direction.NORTH));
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block<?> currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, BlockLogicChest.getMetaWithDirection(BlockLogicChest.getMetaWithType(currentMeta, BlockLogicChest.Type.SINGLE), Direction.NORTH));
     }
 
     private ItemStack[] chestContents;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index 97f5d0948..e968923ec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -76,7 +76,7 @@ public class TileEntityDispatcher {
         addMapping(TileEntitySign.class, new NamespaceID("minecraft", "sign"));
         addMapping(TileEntityMobSpawner.class, new NamespaceID("minecraft", "mob_spawner"));
         addMapping(TileEntityMovingPistonBlock.class, new NamespaceID("minecraft", "piston_moving"));
-        addMapping(TileEntityFurnaceBlastFurnace.class, new NamespaceID("minecraft", "furnace_blast"));
+        addMapping(TileEntityFurnaceBlast.class, new NamespaceID("minecraft", "furnace_blast"));
         addMapping(TileEntitySensor.class, new NamespaceID("minecraft", "sensor"));
         addMapping(TileEntityTrommel.class, new NamespaceID("minecraft", "trommel"));
         addMapping(TileEntityBasket.class, new NamespaceID("minecraft", "basket"));
@@ -131,7 +131,7 @@ public class TileEntityDispatcher {
             addMapping(TileEntityMobSpawner.class, "MobSpawner");
             addMapping(TileEntityNoteblock.class, "Music");
             addMapping(TileEntityMovingPistonBlock.class, "Piston");
-            addMapping(TileEntityFurnaceBlastFurnace.class, "BlastFurnace");
+            addMapping(TileEntityFurnaceBlast.class, "BlastFurnace");
             addMapping(TileEntitySensor.class, "Sensor");
             addMapping(TileEntityTrommel.class, "Trommel");
             addMapping(TileEntityBasket.class, "Basket");
